/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.benutzerverwaltung.boundary;

import de.ivu.elect.business.benutzerverwaltung.entity.Rolle;

@javax.enterprise.context.ApplicationScoped // ELECT-7845
public class RolleDAO extends AbstractRolleDAO {

  private static final long serialVersionUID = 1L;

  @javax.inject.Inject
  private transient de.ivu.elect.jee.entity.SimpleDAO simpleDAO;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return simpleDAO.getEntityManager();
  }

  public void persist(Rolle rolle){
    getEntityManager().persist(rolle);
  }

  public void remove(Rolle rolle){
    getEntityManager().remove(rolle);
  }

@javax.inject.Inject
private transient de.ivu.elect.presentation.system.DAOCache daoCache;

                    
        /**
        * Name: AllNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT OBJECT(o) FROM Rolle o WHERE o.mandant = ?1<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Rolle> findByAll( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Rolle.findByAll" ,  mandant  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByAll( mandant  ));
        }
        return (java.util.List<Rolle>) cached;
        }
            return super.findByAll( mandant  );
            }
                                        
        /**
        * Name: BenutzerEinsatzortNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT o FROM Rolle o, BenutzerEinsatzort b WHERE o MEMBER OF b.rolles AND b=?1<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Rolle> findByBenutzerEinsatzort( @javax.annotation.Nonnull de.ivu.elect.business.benutzerverwaltung.entity.BenutzerEinsatzort benutzerEinsatzort) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Rolle.findByBenutzerEinsatzort" ,  benutzerEinsatzort  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByBenutzerEinsatzort( benutzerEinsatzort  ));
        }
        return (java.util.List<Rolle>) cached;
        }
            return super.findByBenutzerEinsatzort( benutzerEinsatzort  );
            }
                                        
        /**
        * Name: BenutzerNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT o FROM Rolle o, Benutzer b WHERE o MEMBER OF b.rolles AND b=?1<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Rolle> findByBenutzer( @javax.annotation.Nonnull de.ivu.elect.business.benutzerverwaltung.entity.Benutzer benutzer) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Rolle.findByBenutzer" ,  benutzer  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByBenutzer( benutzer  ));
        }
        return (java.util.List<Rolle>) cached;
        }
            return super.findByBenutzer( benutzer  );
            }
                                        
        /**
        * Name: GebietRolleNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT o FROM Rolle o WHERE (SELECT COUNT(g) FROM Gebiet g WHERE g.einsehenRolle = o)>0 OR (SELECT COUNT(g) FROM Gebiet g WHERE g.bearbeitenRolle = o)>0 AND o.mandant = ?1<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Rolle> findByGebietRolle( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Rolle.findByGebietRolle" ,  mandant  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByGebietRolle( mandant  ));
        }
        return (java.util.List<Rolle>) cached;
        }
            return super.findByGebietRolle( mandant  );
            }
                                        
        /**
        * Name: NameNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT OBJECT(o) FROM Rolle o WHERE o.mandant = ?1 AND o.name=?2<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Rolle> findByName( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant,  @javax.annotation.Nonnull String name) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Rolle.findByName" ,  mandant ,  name  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByName( mandant ,  name  ));
        }
        return (java.util.List<Rolle>) cached;
        }
            return super.findByName( mandant ,  name  );
            }
                                                                            
        /**
        * Name: WahlRolleNoFlush<br>
        * Beschreibung: <br>
        * EJBQL: SELECT o FROM Rolle o WHERE (SELECT COUNT(w) FROM Wahl w WHERE w.einsehenRolle = o)>0 OR (SELECT COUNT(w) FROM Wahltermin w WHERE w.einsehenRolle = o)>0 AND o.mandant=?1<br>
        * SQL: <br>
        */
        @Override
        public java.util.List<Rolle> findByWahlRolle( @javax.annotation.Nonnull de.ivu.elect.business.mandant.entity.Mandant mandant) {

        if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
        de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Rolle.findByWahlRolle" ,  mandant  );

        Object cached = daoCache.findInCache(key);

        if (cached==null) {
          return daoCache.cache(key, super.findByWahlRolle( mandant  ));
        }
        return (java.util.List<Rolle>) cached;
        }
            return super.findByWahlRolle( mandant  );
            }
                    
@Override
public void clear() {
super.clear();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}

}

@Override
public void flush() {
super.flush();
if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES_DAO) {
daoCache.clear();
}
}



}